package u8c.ui.mmpac.action;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JSplitPane;
import javax.swing.border.BevelBorder;

import cn.hutool.core.lang.UUID;
import nc.bs.framework.common.NCLocator;
import nc.bs.uap.oid.OidGenerator;
import nc.hr.utils.PubEnv;
import nc.itf.am.prv.ISale;
import nc.itf.scm.so.so001.ISaleOrder;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.generator.IdGenerator;
import nc.jdbc.framework.generator.SequenceGenerator;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.md.data.access.NCObject;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.ui.querytemplate.QueryConditionDLG;
import nc.vo.am.sale.SaleBillVO;
import nc.vo.am.sale.SaleHeadVO;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.PfUtilWorkFlowVO;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import nc.vo.querytemplate.TemplateInfo;
import nc.vo.so.so001.SaleOrderVO;
import nc.vo.so.so001.SaleorderBVO;
import nc.vo.so.so001.SaleorderHVO;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.bs.upifsp.pub.UpifsTool;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.out.ISaleOutMaintainAPI;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;

@SuppressWarnings("deprecation")
public class ToSaleOutDialog extends UIDialog implements ActionListener,BillEditListener{

	private static final long serialVersionUID = -2605551888165671266L;
	private int focus=1;
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPanel2 = null;
	private UISplitPane mainpanel = null;
	private BillCardPanel jlcardPanel = null;//卡面面板
	private UIPanel jlbtnpanel = null;//存放按钮的panel
	private UIButton saveCardBtn = null ; //保存
	private UIButton cancelBtn = null ; //取消
	private UIButton selectallBtn= null ; //全选按钮
	private UIButton cancelallBtn= null ; //全消按钮
	private UIButton queryBtn= null ;//查询按钮 
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private HRAggVO aggvo;
	private OrderInVO[] inArrays = null;
	private  ISaleOutMaintainAPI isaleout = NCLocator.getInstance().lookup(ISaleOutMaintainAPI.class);
	private  ISaleOrder isoservice = (ISaleOrder) NCLocator.getInstance().lookup(ISaleOrder.class.getName());
	private  IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
	private IplatFormEntry iIplatFormEntry = NCLocator.getInstance().lookup(IplatFormEntry.class);
	public ToSaleOutDialog(HRAggVO aggvo) {
		super();
		initialize(aggvo);
	}

//	private void initialize(HRAggVO aggvo) {
//		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
//		setName("saleoutdlg");
//		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
//		setTitle("生产总订单入库-销售出库");
//		setSize(1000,360);
//		this.setResizable(true);
//		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
//		setContentPane(getMainPanel());
//		addListenerEvent();
//		this.aggvo = aggvo;
//		//展示数据
//		OrderInVO[] inArrays = getInVOs(aggvo);
//		getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
//	}
	
	private void initialize(HRAggVO aggvo) {
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("saleoutdlg");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("生产总订单入库-销售出库");
		setSize(dimension.width-100,dimension.height-200);
		int width=dimension.width;
		int height=dimension.height;
		this.setResizable(true);
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPanel2(), BorderLayout.CENTER);
		setLocation(100/2, 200/2);
//		setContentPane(getMainPanel());
		addListenerEvent();
		this.aggvo = aggvo;
		//展示数据
		OrderInVO[] inArrays = getInVOs(aggvo);
		getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
	}
	
	
	
	

	//按钮监听
	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getQueryBtn().addActionListener(this);
		getSelectallBtn().addActionListener(this);
		getCancelallBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
		
	}
	
	private UIPanel getUIPanel2() {
		if (ivjUIPanel2 == null) {
			ivjUIPanel2 = new UIPanel();
			ivjUIPanel2.setLayout(new BorderLayout());
			ivjUIPanel2.setPreferredSize(new Dimension(0, 500));
	//		ivjUIPanel2.add(getMainPanel(), BorderLayout.CENTER);// ZTH
			ivjUIPanel2.add(getJlbtnpanel(), BorderLayout.SOUTH);// ZTH
			ivjUIPanel2.add(getJlcardPanel(), BorderLayout.CENTER);// ZTH
		}
		return this.ivjUIPanel2;
	}
	
	
	private UIPanel getUIPanel0() {
		if (ivjUIPanel0 == null) {
			try {
				ivjUIPanel0 = new UIPanel();
				ivjUIPanel0.setLayout(new FlowLayout(FlowLayout.LEFT));
				ivjUIPanel0.add(getQueryBtn());
				ivjUIPanel0.add(getSelectallBtn());
				ivjUIPanel0.add(getCancelallBtn());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel0;
	}
	
	
   private void handleException(Throwable e) {
		
	}
	

	private UISplitPane getMainPanel() {
		if(mainpanel==null){
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(550);//分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		
		return mainpanel;
	}

	private UIPanel getJlbtnpanel() {
		if(jlbtnpanel==null){
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}

	private UIButton getCancelBtn() {
		if(cancelBtn == null){
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530,210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}

	private UIButton getSaveCardBtn() {
		if(saveCardBtn == null){
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530,210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}
	
	
	private UIButton getQueryBtn() {
		if (queryBtn == null) {
			queryBtn = new UIButton();
			queryBtn.setName("queryBtn");
			queryBtn.setText("  筛选  ");
			Color clrBack = new Color(0XC4C4C4);
			queryBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		
			
		}
		return this.queryBtn;
	}

	
	private UIButton getSelectallBtn() {
		if (selectallBtn == null) {
			selectallBtn = new UIButton();
			selectallBtn.setName("selectallBtn");
			selectallBtn.setText("  全选  ");
			Color clrBack = new Color(0XC4C4C4);
			selectallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		}
		return this.selectallBtn;
	}

	private UIButton getCancelallBtn() {
		if (cancelallBtn == null) {
			cancelallBtn = new UIButton();
			cancelallBtn.setName("cancelallBtn");
			cancelallBtn.setText("  全消  ");
			Color clrBack = new Color(0XC4C4C4);
			cancelallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		}
		return this.cancelallBtn;
	}
	

	private BillCardPanel getJlcardPanel() {
		if(jlcardPanel==null){
			jlcardPanel=new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			//根据单据模板编码加载模板
//			jlcardPanel.loadTemplet("A224C",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
			jlcardPanel.loadTemplet("QS412",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
		}
		
		return jlcardPanel;
	}
	
	//根据传入的aggvo获取invo数组
	private OrderInVO[] getInVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		//查询最新的数据
		OrderMainVO headvo=(OrderMainVO) aggvo.getParentVO();
		String pk_order=headvo.getPk_order();//主表主键
		IUAPQueryBS iuap=NCLocator.getInstance().lookup(IUAPQueryBS.class);
		String sql="select * from mmpac_order_in where pk_order='"+pk_order+"' and isnull(dr,0)=0  ";
		List<OrderInVO> orderinvos=null;
		try {
			orderinvos=(List<OrderInVO>) iuap.executeQuery(sql, new BeanListProcessor(OrderInVO.class));
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		List<OrderInVO> invos = new ArrayList<OrderInVO>();
//		for(CircularlyAccessibleValueObject vo : vos) {
//			if(vo instanceof OrderInVO) {
//				//本次执行数量不填就默认
//				//执行完的表体在生单界面不展示
//				OrderInVO invo = (OrderInVO) vo;
//				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
//				UFDouble execnum = invo.getExecnum() == null ? new UFDouble(0) : invo.getExecnum();
////				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
////					continue;
////				}
//				if(num.sub(execnum).compareTo(UFDouble.ZERO_DBL)==0) {
//					continue;
//				}
//				invo.setBdef5(num.sub(execnum).toString());
//				invos.add(invo);
//			}
//		}
//		OrderInVO[] inArrays = new OrderInVO[invos.size()];
//		for(int i = 0;i < invos.size();i++) {
//			inArrays[i] = invos.get(i);
//		}
		
		List<OrderInVO> issuevos = new ArrayList<OrderInVO>();
		if(null!=orderinvos && orderinvos.size()>0) {
			for(OrderInVO invo:orderinvos) {
				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
				UFDouble bdef8 = invo.getBdef8()== null ? UFDouble.ZERO_DBL :new UFDouble(invo.getBdef8());//销售出库已执行主数量
				if(num.sub(bdef8).compareTo(UFDouble.ZERO_DBL)==0) {
					continue;
				}
				invo.setBdef5(num.sub(bdef8).toString());
				invos.add(invo);
			}
			
		}else {
			
			for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderInVO) {
				//本次执行数量不填就默认
				//执行完的表体在生单界面不展示
				OrderInVO invo = (OrderInVO) vo;
				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
				UFDouble bdef8 = invo.getBdef8() == null ?UFDouble.ZERO_DBL : new UFDouble(invo.getBdef8());
//				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
//					continue;
//				}
				if(num.sub(bdef8).compareTo(UFDouble.ZERO_DBL)==0) {
					continue;
				}
				invo.setBdef5(num.sub(bdef8).toString());
				invos.add(invo);
			}
		}
		
	}
		
		OrderInVO [] issueArrays =invos.toArray(new OrderInVO[0]);
		
		
		return issueArrays;
	}

	@Override
	public void afterEdit(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void bodyRowChange(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}
	
	
	/**
	 * 全选与反选,flag为true时，全选操作，flag为false时，进行反选操作
	 */
	private void onselectall(boolean flag) {
		switch (focus) {
		case 1:
			int jfRowCount = getJlcardPanel().getRowCount();
			if (jfRowCount > 0) {
				for (int row = 0; row < jfRowCount; row++) {
					getJlcardPanel().getBillModel().setValueAt(flag, row, "bdef4");
				}
				
			}
			break;

		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		//保存按钮
		if(e.getSource() == getSaveCardBtn()){
			Vector<Vector<Object>> vectors= getJlcardPanel().getBillModel().getDataVector();
			StringBuffer errmsg = new StringBuffer();
			//数量校验
			try {
				int execsize = 0;//勾选的条数
				for(int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(i);
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						if(vector.get(1) == null) {
							errmsg.append("第"+(i+1)+"行本次执行数量为空！");
							continue;
						}
						execsize = execsize + 1;
						UFDouble execnum = new UFDouble(vector.get(1).toString());//本次执行数量
						UFDouble nnum = new UFDouble(vector.get(22).toString());//主数量
						UFDouble usednum = vector.get(51) == null?new UFDouble(0):new UFDouble(vector.get(51).toString());//已执行主数量
						if(execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第"+(i+1)+"行本次执行数量超过订单剩余数量！");
						}
					}
				}
				
				if(!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				if(execsize == 0) {
					MessageDialog.showHintDlg(mainpanel, "提示", "请勾选要生成销售出库的数据");
					return;
				}
				
				OrderMainVO headvo = (OrderMainVO) this.aggvo.getParentVO();
				//业务类型
				String billtype=headvo.getBusitype();
				String pk_corp = headvo.getPk_corp();
				String pk_order = headvo.getPk_order();
				String prjcode = headvo.getProjectid();//项目管理主键
				SaleOrderVO [] saleaggvos=new SaleOrderVO [1];
				SaleOrderVO  saleaggvo=new SaleOrderVO();
				SaleorderHVO saleheadvo =new  SaleorderHVO();
				//项目编码 pk_defdoc9
				saleheadvo.setAttributeValue("pk_defdoc9", prjcode);
				//项目名称pk_defdoc10
				saleheadvo.setAttributeValue("pk_defdoc10", prjcode);
				//加工单号pk_defdoc2
				saleheadvo.setAttributeValue("pk_defdoc2", headvo.getDef1());
				saleheadvo.setVnote("来源生产总订单");//备注
				saleheadvo.setAttributeValue("pk_defdoc8", billtype);//业务类型
				saleheadvo.setAttributeValue("bcooptopo", "N");//是否已协同生成采购订单
				saleheadvo.setBfreecustflag(UFBoolean.FALSE);//是否散户
				saleheadvo.setBinitflag(UFBoolean.FALSE);//期初标志
				saleheadvo.setBinvoicendflag(UFBoolean.FALSE);//开票关闭标记
				saleheadvo.setBoutendflag(UFBoolean.FALSE);//出库关闭标记
				saleheadvo.setBoverdate(UFBoolean.FALSE);//是否超帐期
				saleheadvo.setAttributeValue("bpocooptome", "N");//是否由采购订单协同生成 
				saleheadvo.setBreceiptendflag(UFBoolean.FALSE);//发货关闭标记 
				saleheadvo.setBretinvflag(UFBoolean.FALSE);//退货标记
				saleheadvo.setBtransendflag(UFBoolean.FALSE);//运输关闭标志
				//capproveid 审批人   dapprovedate 审批日期  Daudittime  审批时间
				saleheadvo.setCbiztype(getpkbustype("so02"));//业务类型
				saleheadvo.setCcalbodyid(getvalue("pk_calbody", "bd_calbody", "bodycode", "1001"));// 库存组织
				String def1 = GetBaseDAOUtil.getJobbasmngDef1(prjcode);
				String kh=getpkcumdoc(def1);
				saleheadvo.setCcustomerid(kh);//客户ID 
				saleheadvo.setCdeptid(getvalue("pk_deptdoc", "bd_deptdoc", "deptcode", "16")); //部门
				saleheadvo.setCoperatorid(PubEnv.getPk_user());//制单人 
				saleheadvo.setCreceiptcorpid(kh);//开票单位
				saleheadvo.setCreceiptcustomerid(kh);//收货单位
				saleheadvo.setCreceipttype("30");//单据类型
				saleheadvo.setCsalecorpid(getvalue("csalestruid", "bd_salestru", "vsalestrucode", "10"));//销售组织
				saleheadvo.setDbilldate(PubEnv.getLoginDate());//单据日期
				saleheadvo.setDbilltime(PubEnv.getServerTime());//单据时间
				saleheadvo.setDmakedate(PubEnv.getLoginDate());//制单日期
				saleheadvo.setEditionNum("1.0"); ////修订版本号
				saleheadvo.setFstatus(1);//状态
				saleheadvo.setNdiscountrate(new UFDouble("100.000000")); // 整单折扣 
				saleheadvo.setNevaluatecarriage(UFDouble.ZERO_DBL);//预估运费
	////			saleheadvo.setNheadsummny(new UFDouble("0.88000000")); //金额合计=主数量*数量
				saleheadvo.setPk_corp(pk_corp);//公司ID 
	//			saleheadvo.setVreceiveaddress (pk_corp);//收货地址
				saleaggvo.setParentVO(saleheadvo);
				SaleorderBVO[]  salebodyvos=new SaleorderBVO[execsize];
				Map<String, UFDouble> updatemap = new HashMap<>();
				int k = 0;
				for(int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(j);
					//自定义项4为勾选按钮 ：勾选为Y 没有勾选是null
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						SaleorderBVO sbvo = new SaleorderBVO();
						String cmaterialcode = vector.get(8).toString();
						String pk_invbasdoc = "";//存货pk管理档案主键
						if(cmaterialcode.startsWith("0001")) {
							pk_invbasdoc = cmaterialcode;
						}
						else {
							InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
							pk_invbasdoc = invbasvo.getPrimaryKey();
						}

						String cprojectid=prjcode;
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
						String pk_invmandoc = invmanvo.getPrimaryKey();//存货档案主键
						
						sbvo.setCrowno(j+1+"0");
						sbvo.setBbindflag(UFBoolean.FALSE);
						sbvo.setBdericttrans(UFBoolean.FALSE);
						sbvo.setBlargessflag(UFBoolean.FALSE);
						sbvo.setBoosflag(UFBoolean.FALSE);
						sbvo.setBreturnprofit(UFBoolean.FALSE);
						sbvo.setBsafeprice(UFBoolean.FALSE);
						sbvo.setBsupplyflag(UFBoolean.FALSE);
						sbvo.setCadvisecalbodyid(getvalue("pk_calbody", "bd_calbody", "bodycode", "1001"));//建议发货库存组织
				
						//仓库ID
						if("工装".equals(billtype)) {
							sbvo.setCbodywarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//附表仓库
						}else if("家装".equals(billtype)) {
							sbvo.setCbodywarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//附表仓库
						}
						sbvo.setCcurrencytypeid("00010000000000000001");//原币
						sbvo.setCinvbasdocid(pk_invbasdoc); //存货档案主键
						sbvo.setCinventoryid(pk_invmandoc);//存货ID 
						sbvo.setCinventoryid1(pk_invmandoc);//存货ID 
						sbvo.setCprojectid(prjcode);//项目
						
						 //corder_bid 销售订单附表ID   creceipttype 来源单据类型
						sbvo.setCquoteunitid(GetBaseDAOUtil.getMeasidByName(vector.get(21).toString()));//报价计量单位
						sbvo.setCreceiptcorpid(kh); // 收货单位
						sbvo.setCunitid(GetBaseDAOUtil.getMeasidByName(vector.get(21).toString()));  // 主计量单位
						sbvo.setCpackunitid(vector.get(28) == null ? null : GetBaseDAOUtil.getMeasidByNames(vector.get(28).toString()));  // 辅单位
						sbvo.setDconsigndate(PubEnv.getLoginDate());//发货日期 
						sbvo.setDdeliverdate(PubEnv.getLoginDate()); //交货日期
						UFDouble ninnum = vector.get(1) == null ? null : new UFDouble(vector.get(1).toString());
						sbvo.setNnumber(ninnum);//数量
						UFDouble Hsl = vector.get(49) == null ? null : new UFDouble(vector.get(49).toString());
						//没有换算率则辅数量为空
						UFDouble ninassistnum =UFDouble.ZERO_DBL;
						if(Hsl != null) {
							ninassistnum = new UFDouble(ninnum.div(Hsl).toString(),2);
							sbvo.setNpacknumber(new UFDouble(ninassistnum));//辅数量
						}
						sbvo.setNquoteunitnum(ninnum);//报价单位数量
					
						sbvo.setFbatchstatus(1); //批次状态 
						sbvo.setIncoconfclose("N");
						sbvo.setCbatchid(vector.get(7)==null?"":vector.get(7).toString());//批次
						sbvo.setNdiscountrate(new UFDouble("100"));//整单折扣 
						sbvo.setNexchangeotobrate(UFDouble.ONE_DBL);//折本汇率
						sbvo.setNitemdiscountrate(new UFDouble("100"));//单品折扣率 
						sbvo.setNtaxprice(UFDouble.ONE_DBL);//本币含税单价
						sbvo.setNoriginalcurtaxprice(UFDouble.ONE_DBL);//原币含税单价
						sbvo.setNprice(new UFDouble("0.88000000"));//本币无税单价
						sbvo.setNoriginalcurprice(new UFDouble("0.88000000"));//原币无税单价
						sbvo.setNorgqttaxprc(UFDouble.ONE_DBL);//报价单位含税单价 
						sbvo.setNorgqtprc(new UFDouble("0.88000000"));//报价单位无税单价 
						sbvo.setNnetprice(new UFDouble("0.88000000"));//本币无税净价
						sbvo.setNorgqtnetprc(new UFDouble("0.88000000"));//报价单位无税净价
						sbvo.setNorgqttaxnetprc(UFDouble.ONE_DBL);//报价单位含税净价
						sbvo.setNoriginalcurdiscountmny(UFDouble.ZERO_DBL);//原币折扣额
						sbvo.setNoriginalcurnetprice(new UFDouble("0.88000000"));//原币无税净价
						sbvo.setNoriginalcurtaxnetprice(UFDouble.ONE_DBL);//原币含税净价
						//不含税单价=含税单价/(1+13%)
						UFDouble wsmny=new UFDouble(1/1.13).multiply(ninnum).setScale(2, UFDouble.ROUND_HALF_UP);
						sbvo.setNmny(wsmny);//本币无税金额
						sbvo.setNoriginalcurmny(wsmny);//原币无税金额
						UFDouble noriginalcursummny=UFDouble.ONE_DBL.multiply(ninnum).setScale(2, UFDouble.ROUND_HALF_UP);
						sbvo.setNoriginalcursummny(noriginalcursummny);//原币价税合计	
						sbvo.setNsummny(noriginalcursummny);//本币价税合计
						//税额=价税合计-无税金额
						sbvo.setNoriginalcurtaxmny(noriginalcursummny.sub(wsmny));//原币税额
						sbvo.setNtaxmny(new UFDouble(noriginalcursummny.sub(wsmny)));//本币税额
						
						sbvo.setNqtnetprc(new UFDouble("0.88000000"));//报价单位本币无税净价
						sbvo.setNqtprc(new UFDouble("0.88000000"));//报价单位本币无税单价
						sbvo.setNqttaxnetprc(UFDouble.ONE_DBL);	//报价单位本币含税净价 
						sbvo.setNqttaxprc(UFDouble.ONE_DBL);//报价单位本币含税单价
						sbvo.setNquoteunitrate(UFDouble.ONE_DBL);//报价计量单位换算率
						sbvo.setNreturntaxrate(UFDouble.ZERO_DBL);//出口退税率
						sbvo.setNtaxrate(new UFDouble("13.000000"));//税率
						sbvo.setNtaxnetprice(UFDouble.ONE_DBL);//本币含税净价
						
						sbvo.setPk_corp(saleheadvo.getPk_corp());
	//					sbvo.setRefundflag(UFBoolean.FALSE);
						sbvo.setTconsigntime("00:00:00");//发货时间
						sbvo.setTdelivertime("00:00:00");//到货时间
		//				sbvo.setVreceiveaddress(pk_corp);	//收货地址
						String bidpk=UUID.randomUUID().toString().substring(0, 20);
						sbvo.setCorder_bid(bidpk);//主键
						sbvo.setVfree1(vector.get(12)==null?null:vector.get(12).toString());//颜色
						sbvo.setVfree2(vector.get(14)==null?null:vector.get(14).toString());//合金
						sbvo.setVfree3(vector.get(13)==null?null:vector.get(13).toString());//定尺
						sbvo.setVfree4(vector.get(15)==null?null:vector.get(15).toString());//标准
						sbvo.setAttributeValue("pk_defdoc1", vector.get(37)==null?null:vector.get(37).toString());//楼号楼层
						sbvo.setAttributeValue("pk_defdoc2", vector.get(38)==null?null:vector.get(38).toString());//樘数（数量）
						sbvo.setAttributeValue("pk_defdoc3", vector.get(39)==null?null:vector.get(39).toString());//框统计
						sbvo.setAttributeValue("pk_defdoc4", vector.get(40)==null?null:vector.get(40).toString());//扇统计
						sbvo.setAttributeValue("pk_defdoc5", vector.get(41)==null?null:vector.get(41).toString());//半成品分类
						sbvo.setAttributeValue("pk_defdoc6", vector.get(42)==null?null:vector.get(42).toString());//面积
						sbvo.setAttributeValue("pk_defdoc7", vector.get(43)==null?null:vector.get(43).toString());//切割长度
						sbvo.setAttributeValue("pk_defdoc8", vector.get(44)==null?null:vector.get(44).toString());//切割角度左下
						sbvo.setAttributeValue("pk_defdoc9", vector.get(45)==null?null:vector.get(45).toString());//切割角度右上
						sbvo.setAttributeValue("pk_defdoc10",vector.get(46)==null?null:vector.get(46).toString());//备注
						sbvo.setAttributeValue("pk_defdoc11",vector.get(19)==null?null:vector.get(19).toString());//宽度
						sbvo.setAttributeValue("pk_defdoc12",vector.get(20)==null?null:vector.get(20).toString());//高度
						sbvo.setAttributeValue("pk_defdoc13",vector.get(47)==null?null:vector.get(47).toString());//系列
						sbvo.setAttributeValue("pk_defdoc14",vector.get(48)==null?null:vector.get(48).toString());//玻璃编号
						sbvo.setAttributeValue("pk_defdoc20",vector.get(36)==null?null:vector.get(36).toString());//开票类型
						//回写数量
						UFDouble updatenum =  new UFDouble(vector.get(51)==null?"0":vector.get(51).toString())
								.add(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						updatemap.put(vector.get(34).toString(), updatenum);
						salebodyvos[k]=sbvo;
						k = k + 1;
					}
				}
				saleaggvo.setChildrenVO(salebodyvos);
				ArrayList<String> als=isoservice.insert(saleaggvo);
				SaleOrderVO inseaggvos=new SaleOrderVO();
				SaleorderHVO inserhearvo=(SaleorderHVO) saleaggvo.getParentVO();
				SaleorderBVO[] insersalebodyvos=(SaleorderBVO[]) saleaggvo.getChildrenVO();
				SaleorderHVO newinserhearvo=(SaleorderHVO) inserhearvo.clone();
				SaleorderBVO[] newinsersalebodyvos=insersalebodyvos.clone();
				for(SaleorderBVO bvo:newinsersalebodyvos) {
					bvo.setCsaleid(als.get(0));//主表主键
				}
				newinserhearvo.setCsaleid(als.get(0));
				newinserhearvo.setVreceiptcode(als.get(1));
				newinserhearvo.setCapproveid(PubEnv.getPk_user());
				newinserhearvo.setCcurrencytypeid("00010000000000000001");//币种
			//	newinserhearvo.setAttributeValue("salecorp", "上海欣畅门窗");
				inseaggvos.setParentVO(newinserhearvo);
				inseaggvos.setChildrenVO(newinsersalebodyvos);
				IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
				iIplatFormEntry.processAction("APPROVE", "30", saleheadvo.getDbilldate().toString(), null, inseaggvos, null, null);	
				Boolean updateres = iorder.UpdateInExecNum(updatemap);
				MessageDialog.showHintDlg(mainpanel, "成功", "销售出库单新增成功!");
				this.closeCancel();
			}  catch (Exception e1) {
				MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
				return;
			}
		}
		
		//取消按钮
		if(e.getSource() == getCancelBtn()){
			this.closeCancel();
		}
		
		

		// 全选
		if (e.getSource() == getSelectallBtn()) {
			onselectall(true);
		}

		// 全消
		if (e.getSource() == getCancelallBtn()) {
			onselectall(false);
		}
		
		
		// 筛选
		if (e.getSource() == getQueryBtn()) {
			TemplateInfo ti = new TemplateInfo();
			ti.setTemplateId(null);
			ti.setPk_Org(ce.getCorporation().getPrimaryKey());
			ti.setUserid(ce.getUser().getPrimaryKey());
			ti.setCurrentCorpPk(ce.getCorporation().getPrimaryKey());
			// 功能节点默人模板分配后查询SELECT * from pub_systemplate order by ts desc
			ti.setFunNode("40H204");
			ti.setNodekey("qt");
			QueryConditionDLG d = new QueryConditionDLG(this, ti, "销售出库明细");
			Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
			d.setSize(dimension.width - 1000, dimension.height - 650);
			d.setLocation(500, 300);
			if (d.showModal() != UIDialog.ID_OK) {
				return;
			}

			String dlgsql = d.getWhereSQL();
			if (!(null != dlgsql && !"".equals(dlgsql))) {
				getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
				return;
			}
			String quresql = "select * from mmpac_order_in where  " + dlgsql + " and ";
			IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());

			try {
				List<String> pks = new ArrayList<String>();
				if (null != inArrays && inArrays.length > 0) {
					for (OrderInVO vo : inArrays) {
						String pk_order_in = vo.getPk_order_in();
						pks.add(pk_order_in);
					}
					SqlBuilder sqlbuild = new SqlBuilder();
					sqlbuild.append(quresql);
					sqlbuild.append("pk_order_issue", pks.toArray(new String[0]));
					List<OrderInVO> lisorderinvos = (List<OrderInVO>) iuap.executeQuery(sqlbuild.toString(),
							new BeanListProcessor(OrderInVO.class));
					OrderInVO[] invos = lisorderinvos.toArray(new OrderInVO[0]);
					getJlcardPanel().getBillModel().setBodyDataVO(invos);

				} else {
					getJlcardPanel().getBillModel().setBodyDataVO(null);
				}

			} catch (BusinessException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

		}
	
	}
	
	//客商项目档案
	private String getpkcumdoc(String pk_cubasdoc ) throws BusinessException {
	  String sql="select pk_cumandoc from bd_cumandoc where pk_cubasdoc='"+pk_cubasdoc+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  Object pk_cumandocobj = iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_cumandocobj == null) {
          return "";
      }
      return pk_cumandocobj.toString();
		
	}
	
	//收发类别
	private String getpkrdcl(String rdcode ) throws BusinessException {
	  String sql="select pk_rdcl from bd_rdcl where rdcode='"+rdcode+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  Object pk_rdclobj =  iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_rdclobj == null) {
          return "";
      }
      return pk_rdclobj.toString();
		
	}
	
	//业务流程
	
	private String getpkbustype(String busicode ) throws BusinessException {
		  String sql="select pk_busitype from bd_busitype where busicode='"+busicode+"' and pk_corp='1001'  ";
		  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
		  
		  Object pk_busitype =  iuap.executeQuery(sql, new ColumnProcessor());
	      if (pk_busitype == null) {
	          return "";
	      }
	      return pk_busitype.toString();
			
		}
	
	//通用查询方法
	private String getvalue(String value,String table,String where,String param ) throws BusinessException {
		  String sql="select "+value+" from "+table+" where "+where+"='"+param+"'  ";
		  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
		  
		  Object valueobj =  iuap.executeQuery(sql, new ColumnProcessor());
	      if (valueobj == null) {
	          return "";
	      }
	      return valueobj.toString();
			
		}

}
